/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * Copyright (c) 2001-2002  Fabricio Campos Zuardi.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var bannertags = ["img","embed","object"];

var defaultSizes = "468;60;234;60;120;60;336;280;338;282;728;105;728;90;500;62;184;90;160;600;160;60;150;70;140;800;120;800;120;600;0;0";
var defaultFlags = "1;1;1;0;0;0;0;0;0;0;0;0;0;0;0;0"; //default string with the on/off flags for all the sizes
var defaultVoid = true;	//defalut value for remove/hide
var defaultEnabled = true;

var bannerVoid;
var bannerEnabled;
var sizeenabled;
var bannersizeArray;

function bb_init() { //turn bannerblind on
  var bannerFlags;
  var bannerSizes;

  // getting the configuriation from mozilla preferences
  // note: getting bannerEnabled is deferred until we can check bannersizeArray.length
  var pref;
  try {
    pref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
    bannerSizes = pref.GetCharPref("bannerblind.sizes");
    bannerFlags = pref.GetCharPref("bannerblind.flags");
  } catch (error) {
    bannerSizes = defaultSizes;
    bannerFlags = defaultFlags;
  }

  try {  bannerVoid = pref.GetBoolPref("bannerblind.void"); }
  catch(error) { bannerVoid = defaultVoid; }


  bannersizeArray = bannerSizes.split(";"); //array with all the supported bannersizes
  sizeenabled  = bannerFlags.split(";"); //array with the on/off table

  // remove last item (because of extra ';' character)
  if (bannersizeArray[bannersizeArray.length-1] == '')  bannersizeArray.pop();
  if (sizeenabled[sizeenabled.length-1] == '')          sizeenabled.pop();

  // check preference integrity
  if (bannersizeArray.length > (sizeenabled.length * 2)) {
    bannerSizes = defaultSizes.split(";");
    bannerFlags = defaultFlags.split(";");
  } else
  if (bannersizeArray.length == (sizeenabled.length-1)*2) // fix ver1 RC1 and prior versions
    bannerEnabled = (sizeenabled.shift() == 1);  // remove sizeenabled[0] and set it as bannerVoid
  else {
    try { bannerEnabled = pref.GetBoolPref("bannerblind.enabled") }
    catch(error) { bannerEnabled = defaultEnabled }
  }
  
  // convert array to bools to make later comparisons faster
  for(var j = 0; j < sizeenabled; j++)
    sizeenabled[j] = (sizeenabled[j]!="0");

  //if bannerblind is on
  if(bannerEnabled) bb_scanFrame(window._content);
    // changed: don't hide error messages (document.getElementById("content") undefined)
}


// amalgamation of the old scanFrames and scanPage
function bb_scanFrame(frame) {
  var i, j;
  // examine subframes (if any)
  // handles both <frame> and <iframe>
  var subframes = frame.frames;
  for(i = 0; i < subframes.length; i++)
    bb_scanFrame(subframes);
  // scan this page for img, embed, object
  var page = frame.document;
  for(i = 0; i < bannertags.length; i++) {
    elements = page.getElementsByTagName(bannertags[i]);
    for(j = 0; j < elements.length; j++) 
      bb_remove(elements[j]);
  }
}


function bb_remove(element) {
  for (var i = 0; i < sizeenabled.length; i++) {
    if(!sizeenabled[i]) continue;
    w = bannersizeArray[i*2];
    h = bannersizeArray[i*2+1];
    if(element.width==w && element.height==h) {
      if(bannerVoid)
        element.style.display = "none";
      else
        element.style.visibility = "hidden";
      return;
    }
  }
}


function openBBPrefs(){
  window.open("chrome://bannerblind/content/bannerblindPrefs.xul", "bannerblindwindow", "chrome,top=100,left=100");
}


window.addEventListener("load", bb_init, true);
